ͻ
         Crystal Semiconductor's CS4231 for OS/2 WARP 3.0         
ͼ

Overview
--------

   OS/2 WARP 3 supports the IBM Thinkpad audio which is a CS4231 chip.
   If you have recently purchased a Crystal Semi CS4231 adapter card or,
   a new PC with the CS4231 chipset built-in on the mother-board, this
   device driver package is to setup the OS/2 WARP and WIN-OS2 drivers
   for your adapter.

   ** NOTE: if your system is OS/2 WARP 4.0, please use Selective **
   **       Installation to install the drivers from the WARP 4.0 **
   **       CD-ROM.                                               **


Important
--------- 
   To Unzip this package use PKUNZIP2 with the -d option.  
   Example: PKUNZIP2 XXXXXXXX.ZIP -d, where XXXXXXXX
   is this package file name.  This will create the necessary file structure
   illustrated below and required for successful installation.


File Layout
-----------

   Unpacking the .zip file, you will see the following directory structure:

     <FILE>     AUDPLAY.ICO   ........ icon displayed when wave audio device
     <FILE>     CONTROL.SCR   ........ install control script
     <FILE>     CS4231.SCR    ........ CS4231-specific install script
     <FILE>     MIDIPLAY.ICO  ........ icon displayed when installing OPL3
     <FILE>     OS2SETUP.CMD  ........ the installation program you run
     <FILE>     WINSTALL.CMD  ........ win-os2 install util called by OS2SETUP
     <DIR>      WIN-OS2    ........... contains WIN-OS/2 device driver files
     <DIR>      OS2-WARP   ........... contains OS2 device driver files contains this file
     <DIR>      README     ........... contains this file


Installation
------------
   To install the package, xcopy all the files onto a floppy (you must copy
   with the subdirectories; use the: /s command,  example: xcopy c: a: /s ).

   From the parent directory (where os2setup.cmd resides), type:

     os2setup

   and follow instructions.


Details about the CS4231 Audio Device Driver
--------------------------------------------

   This portion of the README.TXT is from Crystal Semiconductor Corporation.
   It is to provide you with technical espect of the device driver.  If you
   ever encounter problems using the driver, the following topics should
   help you solve them.




                Crystal Semiconductor Corporation

READ.ME - OS/2 Crystal Audio Device Driver Installation Version 1.51
--------------------------------------------------------------------
This file contains information on how to install the Crystal Semiconductor
Corporation Audio Device drivers for the following devices: CS4248, CS4231,
CS4232, CS4236, and CS4237.

The following topics are covered in this READ.ME file :
1)  Installing on top of previous installations
2)  System Requirements
3)  Files List for Crystal Audio Install Disk
4)  Crystal Audio for OS/2 Installation Procedure
5)  Device Driver Command Line Options
6)  Notes on Command Line Options
7)  Using Audio in DOS and Win-OS/2 Sessions
8)  Audio Concurrency Issues - OS/2, DOS, Win-OS/2
9)  Plug and Play System Issues
10) Mixer Issues
11) MIDI Issues
12) Installing Win-OS/2 Drivers


1)  Installing on top of previous installations
-------------------------------------------------------------------------------
Prior to installing, check if the following lines exists in CONFIG.SYS:
    BASEDEV=CS31CONF.SYS ...
    BASEDEV=CS32CONF.SYS ...
    DEVICE=C:\MMOS2\CSBSAUD.SYS ...
    DEVICE=C:\MMOS2\VCSBSAUD.SYS BSAUD1$
    DEVICE=C:\MMOS2\VCSGAMES.SYS BSAUD1$
If any of these entries are present, delete them prior to installing this
product.


2)  System Requirements
-------------------------------------------------------------------------------
Before you install Crystal Audio for OS/2, check to see if you have the
version of MMPM/2 as shipped with OS/2 2.11, or later, installed on your
system.  Use the SYSLEVEL command to determine which level of MMPM/2 you have
installed.  The "Current CSD Level" field displays one of the following
values:

    UN0000  - The version of MMPM/2 as shipped with OS/2 2.1. An update
               is required.
    UN49407 - The October 1993 CSD version of MMPM/2.
               An update is required.
               This is the same version for the OS/2 2.11 service
               refresh of February 1994.
    XR03000 - The version of MMPM/2 as shipped with OS/2 Warp 3.0.
               No update is required.

If an update is required, the MMPM/2 CSD can be obtained free from
Compuserve or from the IBM OS/2 BBS.

CompuServe: OS/2 Support Forum:
    Library 17: mmpmcs.dsk

IBM BBS: (919) 517-0001
    mmoscsd.dsk



3)  File List for Crystal Audio Install Disk
-------------------------------------------------------------------------------

DISK1:   OS/2 Driver Kit
------------------------
BSAUDRES.DLL    -   OS/2 business audio support DLL.
CARDINFO.DLL    -   Crystal device support DLL.
CWAUDIO.HLP     -   Help file used during installation.
CWAUDIO.BIN     -   Audio device microcode.
CWAUDIO.INI     -   Audio settings.
CWAUDIO.SYS     -   Audio physical device driver.
CWCONFIG.SYS    -   Audio device configuration device driver.
CWVAUDIO.SYS    -   Audio virtual device driver.
CONTROL.SCR     -   Installation control file.
FILES.SCR       -   Installation file list.
READ.ME         -   This file.

DISK2:    WIN-OS/2 Driver Kit
-----------------------------
CS32BA11.DRV    -   Windows Wave, Aux, and Mixer Driver
CS32BA11.INI    -   Wave Driver Settings
CSFM.DRV            -   FM MIDI Driver
VSNDSYS.386     -   VXD provides for Windows Dual Boot Support
MIDIMAP.CFG     -   Midimapper for FM MIDI Driver
CWADD.INI           -   Sndsys Settings For System.ini
CWWINOS2.CMD    -   Rexx bases script for Installing Win-OS/2


4)  Crystal Audio for OS/2 Installation Procedure
-------------------------------------------------------------------------------
To install device support, insert the Crystal Audio for OS/2 diskette in
drive A: (or whichever drive Crystal Audio for OS/2 diskette is in).
Start the Multimedia Application Install program which is located in the
Multimedia folder on the OS/2 desktop.  Once you are in the multimedia
installation program, select Source Drive A: (or whichever drive Crystal
Audio for OS/2 diskette is in).

The installation program will show a two Crystal Audio devices in the
Features column: CS4231 and CS4232/36/37...  Select the device that
applies to the Crystal Audio device installed on your system.  Do NOT select
more than one Crystal Semiconductor Audio device.

A check mark will appear next to the feature(s) selected.

Click the install button to proceed with the installation.  Read and follow
the instructions provided by the installation program.  The following files
will be moved onto your system, based on the devices selected :

   \MMOS2\DLL\CARDINFO.DLL
   \MMOS2\DLL\BSAUDRES.DLL
   \MMOS2\HELP\CWAUDIO.HLP
   \MMOS2\CWAUDIO.SYS
   \MMOS2\CWAUDIO.INI
   \MMOS2\CWAUDIO.BIN
   \MMOS2\CWVAUDIO.SYS
   \OS2\CWCONFIG.SYS

Based on your responses to input panels, several lines will be added to the
OS/2 CONFIG.SYS file.  If you do not know how to respond to the input panels,
it is best to NOT change the default settings and click the OK button.  The
following describes the modifications made to your OS/2 CONFIG.SYS file if no
settings are modified, based on the device selected :

    BASEDEV=CWCONFIG.SYS
    DEVICE=C:\MMOS2\CWAUDIO.SYS /N:BSAUD1$ /P:534 /I:5 /D:1,1 /SB:220 /M:NONE /FM:NONE /J:NONE /CD:NONE /L:8
    DEVICE=C:\MMOS2\CWVAUDIO.SYS BSAUD1$



5)  Device Driver Command Line Options
-------------------------------------------------------------------------------
The following tables describe the various command line options and setting
available for the Crystal Audio device drivers.


CWAUDIO.SYS     -   OS/2 audio physical device driver.  This driver supports all
                    Crystal Audio devices.

Option/Format       Description                 Valid Values (* = Default Value)
-------------------------------------------------------------------------------
/A:<asic type>      ASIC Type (CS4231 only)     OPTi928, OPTi929, MAD16, GALLANT, *NONE
/P:<port>           Codec Port                  *534, 608, E84, F44 (hex)
/I:<irq>            Codec IRQ                   *5, 7, 9, 11, 15 (decimal)
/D:<pDMA,cDMA>      Playback,Capture DMA        0, 1, 3 (*1,1)
/CS:<port>          Control Port                (*not required)
/SB:<port>          Sound Blaster Port          *220, 240, NONE
/M:<port,irq>       MPU Port                    330, *NONE
                    MPU IRQ                     7, 9, 11, 12, 15, *NONE
/FM:<port>          FM Port                     *388, NONE
/J:<port>           Joystick Port               100, 200, *NONE
/CD:<type,port>     CD-ROM Type (CS4231 only)   Sony, Mitsumi, Panasonic, *NONE
                    CD-ROM Port                 320, 330, 340, 360, *NONE
/DL:<option>        Download microcode          Force, No (*not required)
/IFM:<option>       Internal FM (CS4236 only)   *On, Off
/O                  Override PnP settings       (*not enabled)
/V                  Enable Verbose Display      (*not enabled)
/N:<name>           Name of PDD                 Supplied by install program (*BSAUD1$)
/X1:<value>         AUX1 unmute/gain            0..31 (8 = 0dB)  (*not enabled - muted)
/X2:<value>         AUX2 unmute/gain            0..31 (8 = 0dB)  (*not enabled - muted)
/L:<value>          LINE unmute/gain            0..31 (8 = 0dB)  (*not enabled - muted)
/R:<rate>           Enable Adj Intrpt Rate      1..60 (interrupts/sec) (*not enabled)
/EXT                Preserve Mixer Input        (*not enabled)
/LCAPT:<source>     Line capture source         L (line), X1 (AUX1), MX (MixOut)
/M:<option>         Microphone Monitoring       1, On (*not enabled)
/S:<value>          Inactivity power down       1..5 minutes (*not enabled)
/V                  Enable Verbose Display      (*not enabled)





CWVAUDIO.SYS     -  OS/2 audio virtual device driver.  This driver supports all
                    Crystal Audio devices.

Option/Format       Description                 Valid Values (* = Default Value)
-------------------------------------------------------------------------------
                    Name of PDD                 Supplied by install program (*BSAUD1$)
/S                  Skip DOS Envir Var Scan     (*not enabled)





6)  Notes on Command Line Options
-------------------------------------------------------------------------------
 CWAUDIO.INI vs Command line options:
 There are two ways to supply CWAUDIO.SYS with options that override default
 settings. The first method is by supplying command-line options in the
 CONFIG.SYS file as specified above. The second method is by supplying entries
 in the CWAUDIO.INI file in the \MMOS2 directory. The first method overrides
 the second on an individual entry basis. Therefore, entries in CWAUDIO.INI
 will be used only when that particular option is not specified in CONFIG.SYS.

 CWVAUDIO.SYS /S Option:
 The CWVAUDIO.SYS driver will automatically set a 'BLASTER' DOS environment
 variable to the proper audio hardware settings.  This is done by adding a
 '@SET BLASTER=' line to the beginning of all DOS session's autoexec file.
 This file is specified in DOS session's DOS_AUTOEXEC property.  The /S option
 for CWVAUDIO.SYS will skip the automatic setting of this environment variable.

 CWAUDIO.SYS /R Option:
 The CWAUDIO.SYS /R option will allow the user to adjust the device interrupt
 rate.  This option should be used with caution.




7)  Using Audio in DOS and Win-OS/2 Sessions
-------------------------------------------------------------------------------
To enable Audio for DOS and Win-OS/2 sessions, you must set DOS properties
to the following:

    WIN_RUN_MODE                 3.1 ENHANCED COMPATIBILITY
    AUDIO_ADAPTER_SHARING        Required or Optional
    INT_DURING_IO                On
    HW_TIMER                     On
    VIDEO_SWITCH_NOTIFICATION    On
    VIDEO_8514A_XGA_IOTRAP       Off
    VIDEO_RETRACE_EMULATION      Off
    DPMI_MEMORY_LIMIT            8




8)  Audio Concurrency Issues - OS/2, DOS, Win-OS/2
-------------------------------------------------------------------------------
OS/2 MMPM/2 is designed such that, when an application is running in
the foreground (has focus), then that application takes priority over
others running in the background.  Background applications are put on hold
until they are placed in the foreground (have focus).

When you have a single audio device, it is not possible for two programs
to use the device at the same time.  For example, if one application has
the device configured for audio playback, and a second application also
configures the device for audio playback, the application with the focus
takes priority and the application in the background is placed on hold.
This situation also exists for sampling rate and sample size configuration.

Audio device drivers for Windows, installed under Win-OS/2, attempt to use
the audio device in all Windows sessions.  For Win-OS/2 sessions which do
not use the audio device, you can set the AUDIO_ADAPTER_SHARING property
to "None".  This prevents the session from accessing the audio device, and
enables the device to be used by other applications.

To display OS/2 online documentation pertinent to system audio, use
view.exe.  Suggested viewing items are:

    VIEW /AUDIO
    VIEW /MULTIMEDIA
    VIEW /SOUNDS



9)  Plug and Play System Issues
-------------------------------------------------------------------------------
The CS4232, CS4236, and CS4237 are Plug and Play (PnP) compatible devices.  If
the system contains a PnP BIOS, the command line options are ignored unless
resource data is not available or /O override option is specified.



10) Mixer Issues
-------------------------------------------------------------------------------
As of this release, there is no generic OS/2 mixer application for Business
Audio.  Therefore, the volume control for devices attached to mixer LINE, AUX1,
and AUX2 is established on the command line of the CWAUDIO.SYS driver.  Refer to
section 5, CWAUDIO.SYS, for the format of the unmute and gain setting options.

These values for gain are set on each boot and cannot be altered during system
operation.  The command line values represent a gain setting where 8 is equal
to 0 dB gain.  Each increment is 1.5 dB.  Values greater than 8 will reduce the
volume and values less than 8 increase the volume.

The devices attached to LINE, AUX1, and AUX2 are system dependent and cannot be
detailed here.  Refer to your system documentation for device configuration.

Note: These settings do not effect standard wave audio volume which is controlled
by the OS/2 volume control ICON.


11) MIDI Issues
-------------------------------------------------------------------------------
Your system may or may not support MIDI audio.  Please refer to your system
documentation for information related to your system's ability to support MIDI
audio.

The CS4236 and CS4237 Crystal Semiconductor Audio device supports an integrated FM
synthesizer.  Therefore, it is recommended that you install the IBM OPL3 driver to
make use of this feature.

12)Installing Win-OS/2 Drivers
-------------------------------------------------------------------------------
To install Crystal Win-OS/2 driver, from an OS/2 command prompt, execute:

        CWWINOS2.CMD WINOS/2DIR OS2DRIVE

                where WINOS/2DIR is the WIN-OS/2 Directory
                and OS2DRIVE is the Drive on which OS/2 is installed.

where WINDIR is the Win-OS/2 directory (usually windir=\OS2\MDOS\WINOS2)

This script will:
1.  Copy the following
WINDIR\SYSTEM\CS32BA11.DRV
WINDIR\CS32BA11.INI
WINDIR\SYSTEM\CSFM.DRV
WINDIR\SYSTEM\VSNDSYS.386
WINDIR\SYSTEM\MIDIMAP.CFG
2.  Modify system.ini.

Please refer to section 7 for recommended Win-OS/2 settings.
